#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - low interrupt status register"]
    pub lisr: LISR,
    #[doc = "0x04 - high interrupt status register"]
    pub hisr: HISR,
    #[doc = "0x08 - low interrupt flag clear register"]
    pub lifcr: LIFCR,
    #[doc = "0x0c - high interrupt flag clear register"]
    pub hifcr: HIFCR,
    #[doc = "0x10 - Stream cluster: S?CR, S?NDTR, S?PAR, S?M0AR, S?M1AR and S?FCR registers"]
    pub st: [ST; 8],
}
#[doc = r" Register block"]
#[repr(C)]
pub struct ST {
    #[doc = "0x00 - stream x configuration register"]
    pub cr: self::st::CR,
    #[doc = "0x04 - stream x number of data register"]
    pub ndtr: self::st::NDTR,
    #[doc = "0x08 - stream x peripheral address register"]
    pub par: self::st::PAR,
    #[doc = "0x0c - stream x memory 0 address register"]
    pub m0ar: self::st::M0AR,
    #[doc = "0x10 - stream x memory 1 address register"]
    pub m1ar: self::st::M1AR,
    #[doc = "0x14 - stream x FIFO control register"]
    pub fcr: self::st::FCR,
}
#[doc = r" Register block"]
#[doc = "Stream cluster: S?CR, S?NDTR, S?PAR, S?M0AR, S?M1AR and S?FCR registers"]
pub mod st;
#[doc = "low interrupt status register"]
pub struct LISR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "low interrupt status register"]
pub mod lisr;
#[doc = "high interrupt status register"]
pub struct HISR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "high interrupt status register"]
pub mod hisr;
#[doc = "low interrupt flag clear register"]
pub struct LIFCR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "low interrupt flag clear register"]
pub mod lifcr;
#[doc = "high interrupt flag clear register"]
pub struct HIFCR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "high interrupt flag clear register"]
pub mod hifcr;
