#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::CKGATENR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `AHB2APB1_CKEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AHB2APB1_CKENR {
    #[doc = "The clock gating is enabled"]
    ENABLED,
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    DISABLED,
}
impl AHB2APB1_CKENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            AHB2APB1_CKENR::ENABLED => false,
            AHB2APB1_CKENR::DISABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> AHB2APB1_CKENR {
        match value {
            false => AHB2APB1_CKENR::ENABLED,
            true => AHB2APB1_CKENR::DISABLED,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline]
    pub fn is_enabled(&self) -> bool {
        *self == AHB2APB1_CKENR::ENABLED
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline]
    pub fn is_disabled(&self) -> bool {
        *self == AHB2APB1_CKENR::DISABLED
    }
}
#[doc = "Possible values of the field `AHB2APB2_CKEN`"]
pub type AHB2APB2_CKENR = AHB2APB1_CKENR;
#[doc = "Possible values of the field `CM4DBG_CKEN`"]
pub type CM4DBG_CKENR = AHB2APB1_CKENR;
#[doc = "Possible values of the field `SPARE_CKEN`"]
pub type SPARE_CKENR = AHB2APB1_CKENR;
#[doc = "Possible values of the field `SRAM_CKEN`"]
pub type SRAM_CKENR = AHB2APB1_CKENR;
#[doc = "Possible values of the field `FLITF_CKEN`"]
pub type FLITF_CKENR = AHB2APB1_CKENR;
#[doc = "Possible values of the field `RCC_CKEN`"]
pub type RCC_CKENR = AHB2APB1_CKENR;
#[doc = "Possible values of the field `EVTCL_CKEN`"]
pub type EVTCL_CKENR = AHB2APB1_CKENR;
#[doc = "Values that can be written to the field `AHB2APB1_CKEN`"]
pub enum AHB2APB1_CKENW {
    #[doc = "The clock gating is enabled"]
    ENABLED,
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    DISABLED,
}
impl AHB2APB1_CKENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            AHB2APB1_CKENW::ENABLED => false,
            AHB2APB1_CKENW::DISABLED => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _AHB2APB1_CKENW<'a> {
    w: &'a mut W,
}
impl<'a> _AHB2APB1_CKENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: AHB2APB1_CKENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The clock gating is enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::ENABLED)
    }
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::DISABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `AHB2APB2_CKEN`"]
pub type AHB2APB2_CKENW = AHB2APB1_CKENW;
#[doc = r" Proxy"]
pub struct _AHB2APB2_CKENW<'a> {
    w: &'a mut W,
}
impl<'a> _AHB2APB2_CKENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: AHB2APB2_CKENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The clock gating is enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::ENABLED)
    }
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::DISABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 1;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CM4DBG_CKEN`"]
pub type CM4DBG_CKENW = AHB2APB1_CKENW;
#[doc = r" Proxy"]
pub struct _CM4DBG_CKENW<'a> {
    w: &'a mut W,
}
impl<'a> _CM4DBG_CKENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CM4DBG_CKENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The clock gating is enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::ENABLED)
    }
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::DISABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SPARE_CKEN`"]
pub type SPARE_CKENW = AHB2APB1_CKENW;
#[doc = r" Proxy"]
pub struct _SPARE_CKENW<'a> {
    w: &'a mut W,
}
impl<'a> _SPARE_CKENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SPARE_CKENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The clock gating is enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::ENABLED)
    }
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::DISABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SRAM_CKEN`"]
pub type SRAM_CKENW = AHB2APB1_CKENW;
#[doc = r" Proxy"]
pub struct _SRAM_CKENW<'a> {
    w: &'a mut W,
}
impl<'a> _SRAM_CKENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SRAM_CKENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The clock gating is enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::ENABLED)
    }
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::DISABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `FLITF_CKEN`"]
pub type FLITF_CKENW = AHB2APB1_CKENW;
#[doc = r" Proxy"]
pub struct _FLITF_CKENW<'a> {
    w: &'a mut W,
}
impl<'a> _FLITF_CKENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: FLITF_CKENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The clock gating is enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::ENABLED)
    }
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::DISABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 5;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `RCC_CKEN`"]
pub type RCC_CKENW = AHB2APB1_CKENW;
#[doc = r" Proxy"]
pub struct _RCC_CKENW<'a> {
    w: &'a mut W,
}
impl<'a> _RCC_CKENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: RCC_CKENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The clock gating is enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::ENABLED)
    }
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::DISABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `EVTCL_CKEN`"]
pub type EVTCL_CKENW = AHB2APB1_CKENW;
#[doc = r" Proxy"]
pub struct _EVTCL_CKENW<'a> {
    w: &'a mut W,
}
impl<'a> _EVTCL_CKENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: EVTCL_CKENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "The clock gating is enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::ENABLED)
    }
    #[doc = "The clock gating is disabled, the clock is always enabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AHB2APB1_CKENW::DISABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 7;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 0 - AHB to APB1 Bridge clock enable"]
    #[inline]
    pub fn ahb2apb1_cken(&self) -> AHB2APB1_CKENR {
        AHB2APB1_CKENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - AHB to APB2 Bridge clock enable"]
    #[inline]
    pub fn ahb2apb2_cken(&self) -> AHB2APB2_CKENR {
        AHB2APB2_CKENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - Cortex M4 ETM clock enable"]
    #[inline]
    pub fn cm4dbg_cken(&self) -> CM4DBG_CKENR {
        CM4DBG_CKENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 3 - Spare clock enable"]
    #[inline]
    pub fn spare_cken(&self) -> SPARE_CKENR {
        SPARE_CKENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 4 - SRAM controller clock enable"]
    #[inline]
    pub fn sram_cken(&self) -> SRAM_CKENR {
        SRAM_CKENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 5 - Flash interface clock enable"]
    #[inline]
    pub fn flitf_cken(&self) -> FLITF_CKENR {
        FLITF_CKENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 6 - RCC clock enable"]
    #[inline]
    pub fn rcc_cken(&self) -> RCC_CKENR {
        RCC_CKENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - EVTCL clock enable"]
    #[inline]
    pub fn evtcl_cken(&self) -> EVTCL_CKENR {
        EVTCL_CKENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 0 - AHB to APB1 Bridge clock enable"]
    #[inline]
    pub fn ahb2apb1_cken(&mut self) -> _AHB2APB1_CKENW {
        _AHB2APB1_CKENW { w: self }
    }
    #[doc = "Bit 1 - AHB to APB2 Bridge clock enable"]
    #[inline]
    pub fn ahb2apb2_cken(&mut self) -> _AHB2APB2_CKENW {
        _AHB2APB2_CKENW { w: self }
    }
    #[doc = "Bit 2 - Cortex M4 ETM clock enable"]
    #[inline]
    pub fn cm4dbg_cken(&mut self) -> _CM4DBG_CKENW {
        _CM4DBG_CKENW { w: self }
    }
    #[doc = "Bit 3 - Spare clock enable"]
    #[inline]
    pub fn spare_cken(&mut self) -> _SPARE_CKENW {
        _SPARE_CKENW { w: self }
    }
    #[doc = "Bit 4 - SRAM controller clock enable"]
    #[inline]
    pub fn sram_cken(&mut self) -> _SRAM_CKENW {
        _SRAM_CKENW { w: self }
    }
    #[doc = "Bit 5 - Flash interface clock enable"]
    #[inline]
    pub fn flitf_cken(&mut self) -> _FLITF_CKENW {
        _FLITF_CKENW { w: self }
    }
    #[doc = "Bit 6 - RCC clock enable"]
    #[inline]
    pub fn rcc_cken(&mut self) -> _RCC_CKENW {
        _RCC_CKENW { w: self }
    }
    #[doc = "Bit 7 - EVTCL clock enable"]
    #[inline]
    pub fn evtcl_cken(&mut self) -> _EVTCL_CKENW {
        _EVTCL_CKENW { w: self }
    }
}
