#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SMPR1 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `SMP18`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SMP18R {
    #[doc = "3 cycles"]
    CYCLES3,
    #[doc = "15 cycles"]
    CYCLES15,
    #[doc = "28 cycles"]
    CYCLES28,
    #[doc = "56 cycles"]
    CYCLES56,
    #[doc = "84 cycles"]
    CYCLES84,
    #[doc = "112 cycles"]
    CYCLES112,
    #[doc = "144 cycles"]
    CYCLES144,
    #[doc = "480 cycles"]
    CYCLES480,
}
impl SMP18R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            SMP18R::CYCLES3 => 0,
            SMP18R::CYCLES15 => 1,
            SMP18R::CYCLES28 => 2,
            SMP18R::CYCLES56 => 3,
            SMP18R::CYCLES84 => 4,
            SMP18R::CYCLES112 => 5,
            SMP18R::CYCLES144 => 6,
            SMP18R::CYCLES480 => 7,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> SMP18R {
        match value {
            0 => SMP18R::CYCLES3,
            1 => SMP18R::CYCLES15,
            2 => SMP18R::CYCLES28,
            3 => SMP18R::CYCLES56,
            4 => SMP18R::CYCLES84,
            5 => SMP18R::CYCLES112,
            6 => SMP18R::CYCLES144,
            7 => SMP18R::CYCLES480,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `CYCLES3`"]
    #[inline]
    pub fn is_cycles3(&self) -> bool {
        *self == SMP18R::CYCLES3
    }
    #[doc = "Checks if the value of the field is `CYCLES15`"]
    #[inline]
    pub fn is_cycles15(&self) -> bool {
        *self == SMP18R::CYCLES15
    }
    #[doc = "Checks if the value of the field is `CYCLES28`"]
    #[inline]
    pub fn is_cycles28(&self) -> bool {
        *self == SMP18R::CYCLES28
    }
    #[doc = "Checks if the value of the field is `CYCLES56`"]
    #[inline]
    pub fn is_cycles56(&self) -> bool {
        *self == SMP18R::CYCLES56
    }
    #[doc = "Checks if the value of the field is `CYCLES84`"]
    #[inline]
    pub fn is_cycles84(&self) -> bool {
        *self == SMP18R::CYCLES84
    }
    #[doc = "Checks if the value of the field is `CYCLES112`"]
    #[inline]
    pub fn is_cycles112(&self) -> bool {
        *self == SMP18R::CYCLES112
    }
    #[doc = "Checks if the value of the field is `CYCLES144`"]
    #[inline]
    pub fn is_cycles144(&self) -> bool {
        *self == SMP18R::CYCLES144
    }
    #[doc = "Checks if the value of the field is `CYCLES480`"]
    #[inline]
    pub fn is_cycles480(&self) -> bool {
        *self == SMP18R::CYCLES480
    }
}
#[doc = "Possible values of the field `SMP17`"]
pub type SMP17R = SMP18R;
#[doc = "Possible values of the field `SMP16`"]
pub type SMP16R = SMP18R;
#[doc = "Possible values of the field `SMP15`"]
pub type SMP15R = SMP18R;
#[doc = "Possible values of the field `SMP14`"]
pub type SMP14R = SMP18R;
#[doc = "Possible values of the field `SMP13`"]
pub type SMP13R = SMP18R;
#[doc = "Possible values of the field `SMP12`"]
pub type SMP12R = SMP18R;
#[doc = "Possible values of the field `SMP11`"]
pub type SMP11R = SMP18R;
#[doc = "Possible values of the field `SMP10`"]
pub type SMP10R = SMP18R;
#[doc = "Values that can be written to the field `SMP18`"]
pub enum SMP18W {
    #[doc = "3 cycles"]
    CYCLES3,
    #[doc = "15 cycles"]
    CYCLES15,
    #[doc = "28 cycles"]
    CYCLES28,
    #[doc = "56 cycles"]
    CYCLES56,
    #[doc = "84 cycles"]
    CYCLES84,
    #[doc = "112 cycles"]
    CYCLES112,
    #[doc = "144 cycles"]
    CYCLES144,
    #[doc = "480 cycles"]
    CYCLES480,
}
impl SMP18W {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            SMP18W::CYCLES3 => 0,
            SMP18W::CYCLES15 => 1,
            SMP18W::CYCLES28 => 2,
            SMP18W::CYCLES56 => 3,
            SMP18W::CYCLES84 => 4,
            SMP18W::CYCLES112 => 5,
            SMP18W::CYCLES144 => 6,
            SMP18W::CYCLES480 => 7,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SMP18W<'a> {
    w: &'a mut W,
}
impl<'a> _SMP18W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SMP18W) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3 cycles"]
    #[inline]
    pub fn cycles3(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES3)
    }
    #[doc = "15 cycles"]
    #[inline]
    pub fn cycles15(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES15)
    }
    #[doc = "28 cycles"]
    #[inline]
    pub fn cycles28(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES28)
    }
    #[doc = "56 cycles"]
    #[inline]
    pub fn cycles56(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES56)
    }
    #[doc = "84 cycles"]
    #[inline]
    pub fn cycles84(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES84)
    }
    #[doc = "112 cycles"]
    #[inline]
    pub fn cycles112(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES112)
    }
    #[doc = "144 cycles"]
    #[inline]
    pub fn cycles144(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES144)
    }
    #[doc = "480 cycles"]
    #[inline]
    pub fn cycles480(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES480)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 24;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SMP17`"]
pub type SMP17W = SMP18W;
#[doc = r" Proxy"]
pub struct _SMP17W<'a> {
    w: &'a mut W,
}
impl<'a> _SMP17W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SMP17W) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3 cycles"]
    #[inline]
    pub fn cycles3(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES3)
    }
    #[doc = "15 cycles"]
    #[inline]
    pub fn cycles15(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES15)
    }
    #[doc = "28 cycles"]
    #[inline]
    pub fn cycles28(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES28)
    }
    #[doc = "56 cycles"]
    #[inline]
    pub fn cycles56(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES56)
    }
    #[doc = "84 cycles"]
    #[inline]
    pub fn cycles84(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES84)
    }
    #[doc = "112 cycles"]
    #[inline]
    pub fn cycles112(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES112)
    }
    #[doc = "144 cycles"]
    #[inline]
    pub fn cycles144(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES144)
    }
    #[doc = "480 cycles"]
    #[inline]
    pub fn cycles480(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES480)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 21;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SMP16`"]
pub type SMP16W = SMP18W;
#[doc = r" Proxy"]
pub struct _SMP16W<'a> {
    w: &'a mut W,
}
impl<'a> _SMP16W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SMP16W) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3 cycles"]
    #[inline]
    pub fn cycles3(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES3)
    }
    #[doc = "15 cycles"]
    #[inline]
    pub fn cycles15(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES15)
    }
    #[doc = "28 cycles"]
    #[inline]
    pub fn cycles28(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES28)
    }
    #[doc = "56 cycles"]
    #[inline]
    pub fn cycles56(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES56)
    }
    #[doc = "84 cycles"]
    #[inline]
    pub fn cycles84(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES84)
    }
    #[doc = "112 cycles"]
    #[inline]
    pub fn cycles112(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES112)
    }
    #[doc = "144 cycles"]
    #[inline]
    pub fn cycles144(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES144)
    }
    #[doc = "480 cycles"]
    #[inline]
    pub fn cycles480(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES480)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 18;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SMP15`"]
pub type SMP15W = SMP18W;
#[doc = r" Proxy"]
pub struct _SMP15W<'a> {
    w: &'a mut W,
}
impl<'a> _SMP15W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SMP15W) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3 cycles"]
    #[inline]
    pub fn cycles3(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES3)
    }
    #[doc = "15 cycles"]
    #[inline]
    pub fn cycles15(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES15)
    }
    #[doc = "28 cycles"]
    #[inline]
    pub fn cycles28(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES28)
    }
    #[doc = "56 cycles"]
    #[inline]
    pub fn cycles56(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES56)
    }
    #[doc = "84 cycles"]
    #[inline]
    pub fn cycles84(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES84)
    }
    #[doc = "112 cycles"]
    #[inline]
    pub fn cycles112(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES112)
    }
    #[doc = "144 cycles"]
    #[inline]
    pub fn cycles144(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES144)
    }
    #[doc = "480 cycles"]
    #[inline]
    pub fn cycles480(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES480)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SMP14`"]
pub type SMP14W = SMP18W;
#[doc = r" Proxy"]
pub struct _SMP14W<'a> {
    w: &'a mut W,
}
impl<'a> _SMP14W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SMP14W) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3 cycles"]
    #[inline]
    pub fn cycles3(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES3)
    }
    #[doc = "15 cycles"]
    #[inline]
    pub fn cycles15(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES15)
    }
    #[doc = "28 cycles"]
    #[inline]
    pub fn cycles28(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES28)
    }
    #[doc = "56 cycles"]
    #[inline]
    pub fn cycles56(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES56)
    }
    #[doc = "84 cycles"]
    #[inline]
    pub fn cycles84(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES84)
    }
    #[doc = "112 cycles"]
    #[inline]
    pub fn cycles112(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES112)
    }
    #[doc = "144 cycles"]
    #[inline]
    pub fn cycles144(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES144)
    }
    #[doc = "480 cycles"]
    #[inline]
    pub fn cycles480(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES480)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SMP13`"]
pub type SMP13W = SMP18W;
#[doc = r" Proxy"]
pub struct _SMP13W<'a> {
    w: &'a mut W,
}
impl<'a> _SMP13W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SMP13W) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3 cycles"]
    #[inline]
    pub fn cycles3(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES3)
    }
    #[doc = "15 cycles"]
    #[inline]
    pub fn cycles15(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES15)
    }
    #[doc = "28 cycles"]
    #[inline]
    pub fn cycles28(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES28)
    }
    #[doc = "56 cycles"]
    #[inline]
    pub fn cycles56(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES56)
    }
    #[doc = "84 cycles"]
    #[inline]
    pub fn cycles84(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES84)
    }
    #[doc = "112 cycles"]
    #[inline]
    pub fn cycles112(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES112)
    }
    #[doc = "144 cycles"]
    #[inline]
    pub fn cycles144(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES144)
    }
    #[doc = "480 cycles"]
    #[inline]
    pub fn cycles480(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES480)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SMP12`"]
pub type SMP12W = SMP18W;
#[doc = r" Proxy"]
pub struct _SMP12W<'a> {
    w: &'a mut W,
}
impl<'a> _SMP12W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SMP12W) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3 cycles"]
    #[inline]
    pub fn cycles3(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES3)
    }
    #[doc = "15 cycles"]
    #[inline]
    pub fn cycles15(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES15)
    }
    #[doc = "28 cycles"]
    #[inline]
    pub fn cycles28(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES28)
    }
    #[doc = "56 cycles"]
    #[inline]
    pub fn cycles56(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES56)
    }
    #[doc = "84 cycles"]
    #[inline]
    pub fn cycles84(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES84)
    }
    #[doc = "112 cycles"]
    #[inline]
    pub fn cycles112(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES112)
    }
    #[doc = "144 cycles"]
    #[inline]
    pub fn cycles144(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES144)
    }
    #[doc = "480 cycles"]
    #[inline]
    pub fn cycles480(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES480)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SMP11`"]
pub type SMP11W = SMP18W;
#[doc = r" Proxy"]
pub struct _SMP11W<'a> {
    w: &'a mut W,
}
impl<'a> _SMP11W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SMP11W) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3 cycles"]
    #[inline]
    pub fn cycles3(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES3)
    }
    #[doc = "15 cycles"]
    #[inline]
    pub fn cycles15(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES15)
    }
    #[doc = "28 cycles"]
    #[inline]
    pub fn cycles28(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES28)
    }
    #[doc = "56 cycles"]
    #[inline]
    pub fn cycles56(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES56)
    }
    #[doc = "84 cycles"]
    #[inline]
    pub fn cycles84(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES84)
    }
    #[doc = "112 cycles"]
    #[inline]
    pub fn cycles112(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES112)
    }
    #[doc = "144 cycles"]
    #[inline]
    pub fn cycles144(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES144)
    }
    #[doc = "480 cycles"]
    #[inline]
    pub fn cycles480(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES480)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 3;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SMP10`"]
pub type SMP10W = SMP18W;
#[doc = r" Proxy"]
pub struct _SMP10W<'a> {
    w: &'a mut W,
}
impl<'a> _SMP10W<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SMP10W) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "3 cycles"]
    #[inline]
    pub fn cycles3(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES3)
    }
    #[doc = "15 cycles"]
    #[inline]
    pub fn cycles15(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES15)
    }
    #[doc = "28 cycles"]
    #[inline]
    pub fn cycles28(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES28)
    }
    #[doc = "56 cycles"]
    #[inline]
    pub fn cycles56(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES56)
    }
    #[doc = "84 cycles"]
    #[inline]
    pub fn cycles84(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES84)
    }
    #[doc = "112 cycles"]
    #[inline]
    pub fn cycles112(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES112)
    }
    #[doc = "144 cycles"]
    #[inline]
    pub fn cycles144(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES144)
    }
    #[doc = "480 cycles"]
    #[inline]
    pub fn cycles480(self) -> &'a mut W {
        self.variant(SMP18W::CYCLES480)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 24:26 - Channel 18 sampling time selection"]
    #[inline]
    pub fn smp18(&self) -> SMP18R {
        SMP18R::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 24;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 21:23 - Channel 17 sampling time selection"]
    #[inline]
    pub fn smp17(&self) -> SMP17R {
        SMP17R::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 21;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 18:20 - Channel 16 sampling time selection"]
    #[inline]
    pub fn smp16(&self) -> SMP16R {
        SMP16R::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 18;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 15:17 - Channel 15 sampling time selection"]
    #[inline]
    pub fn smp15(&self) -> SMP15R {
        SMP15R::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 12:14 - Channel 14 sampling time selection"]
    #[inline]
    pub fn smp14(&self) -> SMP14R {
        SMP14R::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 9:11 - Channel 13 sampling time selection"]
    #[inline]
    pub fn smp13(&self) -> SMP13R {
        SMP13R::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 6:8 - Channel 12 sampling time selection"]
    #[inline]
    pub fn smp12(&self) -> SMP12R {
        SMP12R::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 3:5 - Channel 11 sampling time selection"]
    #[inline]
    pub fn smp11(&self) -> SMP11R {
        SMP11R::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 0:2 - Channel 10 sampling time selection"]
    #[inline]
    pub fn smp10(&self) -> SMP10R {
        SMP10R::_from({
            const MASK: u8 = 7;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 24:26 - Channel 18 sampling time selection"]
    #[inline]
    pub fn smp18(&mut self) -> _SMP18W {
        _SMP18W { w: self }
    }
    #[doc = "Bits 21:23 - Channel 17 sampling time selection"]
    #[inline]
    pub fn smp17(&mut self) -> _SMP17W {
        _SMP17W { w: self }
    }
    #[doc = "Bits 18:20 - Channel 16 sampling time selection"]
    #[inline]
    pub fn smp16(&mut self) -> _SMP16W {
        _SMP16W { w: self }
    }
    #[doc = "Bits 15:17 - Channel 15 sampling time selection"]
    #[inline]
    pub fn smp15(&mut self) -> _SMP15W {
        _SMP15W { w: self }
    }
    #[doc = "Bits 12:14 - Channel 14 sampling time selection"]
    #[inline]
    pub fn smp14(&mut self) -> _SMP14W {
        _SMP14W { w: self }
    }
    #[doc = "Bits 9:11 - Channel 13 sampling time selection"]
    #[inline]
    pub fn smp13(&mut self) -> _SMP13W {
        _SMP13W { w: self }
    }
    #[doc = "Bits 6:8 - Channel 12 sampling time selection"]
    #[inline]
    pub fn smp12(&mut self) -> _SMP12W {
        _SMP12W { w: self }
    }
    #[doc = "Bits 3:5 - Channel 11 sampling time selection"]
    #[inline]
    pub fn smp11(&mut self) -> _SMP11W {
        _SMP11W { w: self }
    }
    #[doc = "Bits 0:2 - Channel 10 sampling time selection"]
    #[inline]
    pub fn smp10(&mut self) -> _SMP10W {
        _SMP10W { w: self }
    }
}
