#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::SSCGR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `SSCGEN`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SSCGENR {
    #[doc = "Spread spectrum modulation disabled"]
    DISABLED,
    #[doc = "Spread spectrum modulation enabled"]
    ENABLED,
}
impl SSCGENR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SSCGENR::DISABLED => false,
            SSCGENR::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SSCGENR {
        match value {
            false => SSCGENR::DISABLED,
            true => SSCGENR::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline]
    pub fn is_disabled(&self) -> bool {
        *self == SSCGENR::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline]
    pub fn is_enabled(&self) -> bool {
        *self == SSCGENR::ENABLED
    }
}
#[doc = "Possible values of the field `SPREADSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SPREADSELR {
    #[doc = "Center spread"]
    CENTER,
    #[doc = "Down spread"]
    DOWN,
}
impl SPREADSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SPREADSELR::CENTER => false,
            SPREADSELR::DOWN => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SPREADSELR {
        match value {
            false => SPREADSELR::CENTER,
            true => SPREADSELR::DOWN,
        }
    }
    #[doc = "Checks if the value of the field is `CENTER`"]
    #[inline]
    pub fn is_center(&self) -> bool {
        *self == SPREADSELR::CENTER
    }
    #[doc = "Checks if the value of the field is `DOWN`"]
    #[inline]
    pub fn is_down(&self) -> bool {
        *self == SPREADSELR::DOWN
    }
}
#[doc = r" Value of the field"]
pub struct INCSTEPR {
    bits: u16,
}
impl INCSTEPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct MODPERR {
    bits: u16,
}
impl MODPERR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = "Values that can be written to the field `SSCGEN`"]
pub enum SSCGENW {
    #[doc = "Spread spectrum modulation disabled"]
    DISABLED,
    #[doc = "Spread spectrum modulation enabled"]
    ENABLED,
}
impl SSCGENW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SSCGENW::DISABLED => false,
            SSCGENW::ENABLED => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SSCGENW<'a> {
    w: &'a mut W,
}
impl<'a> _SSCGENW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SSCGENW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Spread spectrum modulation disabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(SSCGENW::DISABLED)
    }
    #[doc = "Spread spectrum modulation enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(SSCGENW::ENABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 31;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SPREADSEL`"]
pub enum SPREADSELW {
    #[doc = "Center spread"]
    CENTER,
    #[doc = "Down spread"]
    DOWN,
}
impl SPREADSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SPREADSELW::CENTER => false,
            SPREADSELW::DOWN => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SPREADSELW<'a> {
    w: &'a mut W,
}
impl<'a> _SPREADSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SPREADSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Center spread"]
    #[inline]
    pub fn center(self) -> &'a mut W {
        self.variant(SPREADSELW::CENTER)
    }
    #[doc = "Down spread"]
    #[inline]
    pub fn down(self) -> &'a mut W {
        self.variant(SPREADSELW::DOWN)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 30;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _INCSTEPW<'a> {
    w: &'a mut W,
}
impl<'a> _INCSTEPW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u16) -> &'a mut W {
        const MASK: u16 = 32767;
        const OFFSET: u8 = 13;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _MODPERW<'a> {
    w: &'a mut W,
}
impl<'a> _MODPERW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u16) -> &'a mut W {
        const MASK: u16 = 8191;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 31 - Spread spectrum modulation enable"]
    #[inline]
    pub fn sscgen(&self) -> SSCGENR {
        SSCGENR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 31;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 30 - Spread Select"]
    #[inline]
    pub fn spreadsel(&self) -> SPREADSELR {
        SPREADSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 30;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 13:27 - Incrementation step"]
    #[inline]
    pub fn incstep(&self) -> INCSTEPR {
        let bits = {
            const MASK: u16 = 32767;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u32) as u16
        };
        INCSTEPR { bits }
    }
    #[doc = "Bits 0:12 - Modulation period"]
    #[inline]
    pub fn modper(&self) -> MODPERR {
        let bits = {
            const MASK: u16 = 8191;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u16
        };
        MODPERR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 31 - Spread spectrum modulation enable"]
    #[inline]
    pub fn sscgen(&mut self) -> _SSCGENW {
        _SSCGENW { w: self }
    }
    #[doc = "Bit 30 - Spread Select"]
    #[inline]
    pub fn spreadsel(&mut self) -> _SPREADSELW {
        _SPREADSELW { w: self }
    }
    #[doc = "Bits 13:27 - Incrementation step"]
    #[inline]
    pub fn incstep(&mut self) -> _INCSTEPW {
        _INCSTEPW { w: self }
    }
    #[doc = "Bits 0:12 - Modulation period"]
    #[inline]
    pub fn modper(&mut self) -> _MODPERW {
        _MODPERW { w: self }
    }
}
