#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - CEC control register"]
    pub cec_cr: CEC_CR,
    #[doc = "0x04 - CEC configuration register"]
    pub cec_cfgr: CEC_CFGR,
    #[doc = "0x08 - CEC Tx data register"]
    pub cec_txdr: CEC_TXDR,
    #[doc = "0x0c - CEC Rx Data Register"]
    pub cec_rxdr: CEC_RXDR,
    #[doc = "0x10 - CEC Interrupt and Status Register"]
    pub cec_isr: CEC_ISR,
    #[doc = "0x14 - CEC interrupt enable register"]
    pub cec_ier: CEC_IER,
}
#[doc = "CEC control register"]
pub struct CEC_CR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CEC control register"]
pub mod cec_cr;
#[doc = "CEC configuration register"]
pub struct CEC_CFGR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CEC configuration register"]
pub mod cec_cfgr;
#[doc = "CEC Tx data register"]
pub struct CEC_TXDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CEC Tx data register"]
pub mod cec_txdr;
#[doc = "CEC Rx Data Register"]
pub struct CEC_RXDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CEC Rx Data Register"]
pub mod cec_rxdr;
#[doc = "CEC Interrupt and Status Register"]
pub struct CEC_ISR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CEC Interrupt and Status Register"]
pub mod cec_isr;
#[doc = "CEC interrupt enable register"]
pub struct CEC_IER {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CEC interrupt enable register"]
pub mod cec_ier;
