#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::CIR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `PLLSAIRDYIE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLLSAIRDYIER {
    #[doc = "Interrupt disabled"]
    DISABLED,
    #[doc = "Interrupt enabled"]
    ENABLED,
}
impl PLLSAIRDYIER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PLLSAIRDYIER::DISABLED => false,
            PLLSAIRDYIER::ENABLED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PLLSAIRDYIER {
        match value {
            false => PLLSAIRDYIER::DISABLED,
            true => PLLSAIRDYIER::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline]
    pub fn is_disabled(&self) -> bool {
        *self == PLLSAIRDYIER::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline]
    pub fn is_enabled(&self) -> bool {
        *self == PLLSAIRDYIER::ENABLED
    }
}
#[doc = "Possible values of the field `PLLI2SRDYIE`"]
pub type PLLI2SRDYIER = PLLSAIRDYIER;
#[doc = "Possible values of the field `PLLRDYIE`"]
pub type PLLRDYIER = PLLSAIRDYIER;
#[doc = "Possible values of the field `HSERDYIE`"]
pub type HSERDYIER = PLLSAIRDYIER;
#[doc = "Possible values of the field `HSIRDYIE`"]
pub type HSIRDYIER = PLLSAIRDYIER;
#[doc = "Possible values of the field `LSERDYIE`"]
pub type LSERDYIER = PLLSAIRDYIER;
#[doc = "Possible values of the field `LSIRDYIE`"]
pub type LSIRDYIER = PLLSAIRDYIER;
#[doc = "Possible values of the field `CSSF`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CSSFR {
    #[doc = "No clock security interrupt caused by HSE clock failure"]
    NOTINTERRUPTED,
    #[doc = "Clock security interrupt caused by HSE clock failure"]
    INTERRUPTED,
}
impl CSSFR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CSSFR::NOTINTERRUPTED => false,
            CSSFR::INTERRUPTED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CSSFR {
        match value {
            false => CSSFR::NOTINTERRUPTED,
            true => CSSFR::INTERRUPTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOTINTERRUPTED`"]
    #[inline]
    pub fn is_not_interrupted(&self) -> bool {
        *self == CSSFR::NOTINTERRUPTED
    }
    #[doc = "Checks if the value of the field is `INTERRUPTED`"]
    #[inline]
    pub fn is_interrupted(&self) -> bool {
        *self == CSSFR::INTERRUPTED
    }
}
#[doc = "Possible values of the field `PLLSAIRDYF`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLLSAIRDYFR {
    #[doc = "No clock ready interrupt"]
    NOTINTERRUPTED,
    #[doc = "Clock ready interrupt"]
    INTERRUPTED,
}
impl PLLSAIRDYFR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            PLLSAIRDYFR::NOTINTERRUPTED => false,
            PLLSAIRDYFR::INTERRUPTED => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> PLLSAIRDYFR {
        match value {
            false => PLLSAIRDYFR::NOTINTERRUPTED,
            true => PLLSAIRDYFR::INTERRUPTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOTINTERRUPTED`"]
    #[inline]
    pub fn is_not_interrupted(&self) -> bool {
        *self == PLLSAIRDYFR::NOTINTERRUPTED
    }
    #[doc = "Checks if the value of the field is `INTERRUPTED`"]
    #[inline]
    pub fn is_interrupted(&self) -> bool {
        *self == PLLSAIRDYFR::INTERRUPTED
    }
}
#[doc = "Possible values of the field `PLLI2SRDYF`"]
pub type PLLI2SRDYFR = PLLSAIRDYFR;
#[doc = "Possible values of the field `PLLRDYF`"]
pub type PLLRDYFR = PLLSAIRDYFR;
#[doc = "Possible values of the field `HSERDYF`"]
pub type HSERDYFR = PLLSAIRDYFR;
#[doc = "Possible values of the field `HSIRDYF`"]
pub type HSIRDYFR = PLLSAIRDYFR;
#[doc = "Possible values of the field `LSERDYF`"]
pub type LSERDYFR = PLLSAIRDYFR;
#[doc = "Possible values of the field `LSIRDYF`"]
pub type LSIRDYFR = PLLSAIRDYFR;
#[doc = "Values that can be written to the field `CSSC`"]
pub enum CSSCW {
    #[doc = "Clear CSSF flag"]
    CLEAR,
}
impl CSSCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CSSCW::CLEAR => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CSSCW<'a> {
    w: &'a mut W,
}
impl<'a> _CSSCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CSSCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clear CSSF flag"]
    #[inline]
    pub fn clear(self) -> &'a mut W {
        self.variant(CSSCW::CLEAR)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 23;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLSAIRDYC`"]
pub enum PLLSAIRDYCW {
    #[doc = "Clear interrupt flag"]
    CLEAR,
}
impl PLLSAIRDYCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            PLLSAIRDYCW::CLEAR => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PLLSAIRDYCW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLSAIRDYCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLSAIRDYCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clear interrupt flag"]
    #[inline]
    pub fn clear(self) -> &'a mut W {
        self.variant(PLLSAIRDYCW::CLEAR)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 22;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLI2SRDYC`"]
pub type PLLI2SRDYCW = PLLSAIRDYCW;
#[doc = r" Proxy"]
pub struct _PLLI2SRDYCW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLI2SRDYCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLI2SRDYCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clear interrupt flag"]
    #[inline]
    pub fn clear(self) -> &'a mut W {
        self.variant(PLLSAIRDYCW::CLEAR)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 21;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLRDYC`"]
pub type PLLRDYCW = PLLSAIRDYCW;
#[doc = r" Proxy"]
pub struct _PLLRDYCW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLRDYCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLRDYCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clear interrupt flag"]
    #[inline]
    pub fn clear(self) -> &'a mut W {
        self.variant(PLLSAIRDYCW::CLEAR)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 20;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HSERDYC`"]
pub type HSERDYCW = PLLSAIRDYCW;
#[doc = r" Proxy"]
pub struct _HSERDYCW<'a> {
    w: &'a mut W,
}
impl<'a> _HSERDYCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HSERDYCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clear interrupt flag"]
    #[inline]
    pub fn clear(self) -> &'a mut W {
        self.variant(PLLSAIRDYCW::CLEAR)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 19;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HSIRDYC`"]
pub type HSIRDYCW = PLLSAIRDYCW;
#[doc = r" Proxy"]
pub struct _HSIRDYCW<'a> {
    w: &'a mut W,
}
impl<'a> _HSIRDYCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HSIRDYCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clear interrupt flag"]
    #[inline]
    pub fn clear(self) -> &'a mut W {
        self.variant(PLLSAIRDYCW::CLEAR)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 18;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LSERDYC`"]
pub type LSERDYCW = PLLSAIRDYCW;
#[doc = r" Proxy"]
pub struct _LSERDYCW<'a> {
    w: &'a mut W,
}
impl<'a> _LSERDYCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LSERDYCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clear interrupt flag"]
    #[inline]
    pub fn clear(self) -> &'a mut W {
        self.variant(PLLSAIRDYCW::CLEAR)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 17;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LSIRDYC`"]
pub type LSIRDYCW = PLLSAIRDYCW;
#[doc = r" Proxy"]
pub struct _LSIRDYCW<'a> {
    w: &'a mut W,
}
impl<'a> _LSIRDYCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LSIRDYCW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Clear interrupt flag"]
    #[inline]
    pub fn clear(self) -> &'a mut W {
        self.variant(PLLSAIRDYCW::CLEAR)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 16;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLSAIRDYIE`"]
pub enum PLLSAIRDYIEW {
    #[doc = "Interrupt disabled"]
    DISABLED,
    #[doc = "Interrupt enabled"]
    ENABLED,
}
impl PLLSAIRDYIEW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            PLLSAIRDYIEW::DISABLED => false,
            PLLSAIRDYIEW::ENABLED => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PLLSAIRDYIEW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLSAIRDYIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLSAIRDYIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::DISABLED)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::ENABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 14;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLI2SRDYIE`"]
pub type PLLI2SRDYIEW = PLLSAIRDYIEW;
#[doc = r" Proxy"]
pub struct _PLLI2SRDYIEW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLI2SRDYIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLI2SRDYIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::DISABLED)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::ENABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 13;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLRDYIE`"]
pub type PLLRDYIEW = PLLSAIRDYIEW;
#[doc = r" Proxy"]
pub struct _PLLRDYIEW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLRDYIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLRDYIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::DISABLED)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::ENABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HSERDYIE`"]
pub type HSERDYIEW = PLLSAIRDYIEW;
#[doc = r" Proxy"]
pub struct _HSERDYIEW<'a> {
    w: &'a mut W,
}
impl<'a> _HSERDYIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HSERDYIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::DISABLED)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::ENABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 11;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `HSIRDYIE`"]
pub type HSIRDYIEW = PLLSAIRDYIEW;
#[doc = r" Proxy"]
pub struct _HSIRDYIEW<'a> {
    w: &'a mut W,
}
impl<'a> _HSIRDYIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: HSIRDYIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::DISABLED)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::ENABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 10;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LSERDYIE`"]
pub type LSERDYIEW = PLLSAIRDYIEW;
#[doc = r" Proxy"]
pub struct _LSERDYIEW<'a> {
    w: &'a mut W,
}
impl<'a> _LSERDYIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LSERDYIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::DISABLED)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::ENABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 9;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LSIRDYIE`"]
pub type LSIRDYIEW = PLLSAIRDYIEW;
#[doc = r" Proxy"]
pub struct _LSIRDYIEW<'a> {
    w: &'a mut W,
}
impl<'a> _LSIRDYIEW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LSIRDYIEW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Interrupt disabled"]
    #[inline]
    pub fn disabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::DISABLED)
    }
    #[doc = "Interrupt enabled"]
    #[inline]
    pub fn enabled(self) -> &'a mut W {
        self.variant(PLLSAIRDYIEW::ENABLED)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 14 - PLLSAI Ready Interrupt Enable"]
    #[inline]
    pub fn pllsairdyie(&self) -> PLLSAIRDYIER {
        PLLSAIRDYIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 14;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 13 - PLLI2S ready interrupt enable"]
    #[inline]
    pub fn plli2srdyie(&self) -> PLLI2SRDYIER {
        PLLI2SRDYIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 13;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 12 - Main PLL (PLL) ready interrupt enable"]
    #[inline]
    pub fn pllrdyie(&self) -> PLLRDYIER {
        PLLRDYIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 11 - HSE ready interrupt enable"]
    #[inline]
    pub fn hserdyie(&self) -> HSERDYIER {
        HSERDYIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 11;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 10 - HSI ready interrupt enable"]
    #[inline]
    pub fn hsirdyie(&self) -> HSIRDYIER {
        HSIRDYIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 10;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 9 - LSE ready interrupt enable"]
    #[inline]
    pub fn lserdyie(&self) -> LSERDYIER {
        LSERDYIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 9;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 8 - LSI ready interrupt enable"]
    #[inline]
    pub fn lsirdyie(&self) -> LSIRDYIER {
        LSIRDYIER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 7 - Clock security system interrupt flag"]
    #[inline]
    pub fn cssf(&self) -> CSSFR {
        CSSFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 7;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 6 - PLLSAI ready interrupt flag"]
    #[inline]
    pub fn pllsairdyf(&self) -> PLLSAIRDYFR {
        PLLSAIRDYFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 5 - PLLI2S ready interrupt flag"]
    #[inline]
    pub fn plli2srdyf(&self) -> PLLI2SRDYFR {
        PLLI2SRDYFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 5;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 4 - Main PLL (PLL) ready interrupt flag"]
    #[inline]
    pub fn pllrdyf(&self) -> PLLRDYFR {
        PLLRDYFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 3 - HSE ready interrupt flag"]
    #[inline]
    pub fn hserdyf(&self) -> HSERDYFR {
        HSERDYFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 3;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 2 - HSI ready interrupt flag"]
    #[inline]
    pub fn hsirdyf(&self) -> HSIRDYFR {
        HSIRDYFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 1 - LSE ready interrupt flag"]
    #[inline]
    pub fn lserdyf(&self) -> LSERDYFR {
        LSERDYFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 1;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 0 - LSI ready interrupt flag"]
    #[inline]
    pub fn lsirdyf(&self) -> LSIRDYFR {
        LSIRDYFR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 23 - Clock security system interrupt clear"]
    #[inline]
    pub fn cssc(&mut self) -> _CSSCW {
        _CSSCW { w: self }
    }
    #[doc = "Bit 22 - PLLSAI Ready Interrupt Clear"]
    #[inline]
    pub fn pllsairdyc(&mut self) -> _PLLSAIRDYCW {
        _PLLSAIRDYCW { w: self }
    }
    #[doc = "Bit 21 - PLLI2S ready interrupt clear"]
    #[inline]
    pub fn plli2srdyc(&mut self) -> _PLLI2SRDYCW {
        _PLLI2SRDYCW { w: self }
    }
    #[doc = "Bit 20 - Main PLL(PLL) ready interrupt clear"]
    #[inline]
    pub fn pllrdyc(&mut self) -> _PLLRDYCW {
        _PLLRDYCW { w: self }
    }
    #[doc = "Bit 19 - HSE ready interrupt clear"]
    #[inline]
    pub fn hserdyc(&mut self) -> _HSERDYCW {
        _HSERDYCW { w: self }
    }
    #[doc = "Bit 18 - HSI ready interrupt clear"]
    #[inline]
    pub fn hsirdyc(&mut self) -> _HSIRDYCW {
        _HSIRDYCW { w: self }
    }
    #[doc = "Bit 17 - LSE ready interrupt clear"]
    #[inline]
    pub fn lserdyc(&mut self) -> _LSERDYCW {
        _LSERDYCW { w: self }
    }
    #[doc = "Bit 16 - LSI ready interrupt clear"]
    #[inline]
    pub fn lsirdyc(&mut self) -> _LSIRDYCW {
        _LSIRDYCW { w: self }
    }
    #[doc = "Bit 14 - PLLSAI Ready Interrupt Enable"]
    #[inline]
    pub fn pllsairdyie(&mut self) -> _PLLSAIRDYIEW {
        _PLLSAIRDYIEW { w: self }
    }
    #[doc = "Bit 13 - PLLI2S ready interrupt enable"]
    #[inline]
    pub fn plli2srdyie(&mut self) -> _PLLI2SRDYIEW {
        _PLLI2SRDYIEW { w: self }
    }
    #[doc = "Bit 12 - Main PLL (PLL) ready interrupt enable"]
    #[inline]
    pub fn pllrdyie(&mut self) -> _PLLRDYIEW {
        _PLLRDYIEW { w: self }
    }
    #[doc = "Bit 11 - HSE ready interrupt enable"]
    #[inline]
    pub fn hserdyie(&mut self) -> _HSERDYIEW {
        _HSERDYIEW { w: self }
    }
    #[doc = "Bit 10 - HSI ready interrupt enable"]
    #[inline]
    pub fn hsirdyie(&mut self) -> _HSIRDYIEW {
        _HSIRDYIEW { w: self }
    }
    #[doc = "Bit 9 - LSE ready interrupt enable"]
    #[inline]
    pub fn lserdyie(&mut self) -> _LSERDYIEW {
        _LSERDYIEW { w: self }
    }
    #[doc = "Bit 8 - LSI ready interrupt enable"]
    #[inline]
    pub fn lsirdyie(&mut self) -> _LSIRDYIEW {
        _LSIRDYIEW { w: self }
    }
}
