#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::PLLI2SCFGR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct PLLI2SMR {
    bits: u8,
}
impl PLLI2SMR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct PLLI2SNR {
    bits: u16,
}
impl PLLI2SNR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u16 {
        self.bits
    }
}
#[doc = "Possible values of the field `PLLI2SP`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLLI2SPR {
    #[doc = "PLL*P=2"]
    DIV2,
    #[doc = "PLL*P=4"]
    DIV4,
    #[doc = "PLL*P=6"]
    DIV6,
    #[doc = "PLL*P=8"]
    DIV8,
}
impl PLLI2SPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            PLLI2SPR::DIV2 => 0,
            PLLI2SPR::DIV4 => 1,
            PLLI2SPR::DIV6 => 2,
            PLLI2SPR::DIV8 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> PLLI2SPR {
        match value {
            0 => PLLI2SPR::DIV2,
            1 => PLLI2SPR::DIV4,
            2 => PLLI2SPR::DIV6,
            3 => PLLI2SPR::DIV8,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DIV2`"]
    #[inline]
    pub fn is_div2(&self) -> bool {
        *self == PLLI2SPR::DIV2
    }
    #[doc = "Checks if the value of the field is `DIV4`"]
    #[inline]
    pub fn is_div4(&self) -> bool {
        *self == PLLI2SPR::DIV4
    }
    #[doc = "Checks if the value of the field is `DIV6`"]
    #[inline]
    pub fn is_div6(&self) -> bool {
        *self == PLLI2SPR::DIV6
    }
    #[doc = "Checks if the value of the field is `DIV8`"]
    #[inline]
    pub fn is_div8(&self) -> bool {
        *self == PLLI2SPR::DIV8
    }
}
#[doc = r" Value of the field"]
pub struct PLLI2SQR {
    bits: u8,
}
impl PLLI2SQR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct PLLI2SRR {
    bits: u8,
}
impl PLLI2SRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Proxy"]
pub struct _PLLI2SMW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLI2SMW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 63;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _PLLI2SNW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLI2SNW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        const MASK: u16 = 511;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLI2SP`"]
pub enum PLLI2SPW {
    #[doc = "PLL*P=2"]
    DIV2,
    #[doc = "PLL*P=4"]
    DIV4,
    #[doc = "PLL*P=6"]
    DIV6,
    #[doc = "PLL*P=8"]
    DIV8,
}
impl PLLI2SPW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            PLLI2SPW::DIV2 => 0,
            PLLI2SPW::DIV4 => 1,
            PLLI2SPW::DIV6 => 2,
            PLLI2SPW::DIV8 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PLLI2SPW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLI2SPW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLI2SPW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "PLL*P=2"]
    #[inline]
    pub fn div2(self) -> &'a mut W {
        self.variant(PLLI2SPW::DIV2)
    }
    #[doc = "PLL*P=4"]
    #[inline]
    pub fn div4(self) -> &'a mut W {
        self.variant(PLLI2SPW::DIV4)
    }
    #[doc = "PLL*P=6"]
    #[inline]
    pub fn div6(self) -> &'a mut W {
        self.variant(PLLI2SPW::DIV6)
    }
    #[doc = "PLL*P=8"]
    #[inline]
    pub fn div8(self) -> &'a mut W {
        self.variant(PLLI2SPW::DIV8)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 16;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _PLLI2SQW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLI2SQW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 15;
        const OFFSET: u8 = 24;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _PLLI2SRW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLI2SRW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 7;
        const OFFSET: u8 = 28;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:5 - Division factor for audio PLL (PLLI2S) input clock"]
    #[inline]
    pub fn plli2sm(&self) -> PLLI2SMR {
        let bits = {
            const MASK: u8 = 63;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        PLLI2SMR { bits }
    }
    #[doc = "Bits 6:14 - PLLI2S multiplication factor for VCO"]
    #[inline]
    pub fn plli2sn(&self) -> PLLI2SNR {
        let bits = {
            const MASK: u16 = 511;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) as u16
        };
        PLLI2SNR { bits }
    }
    #[doc = "Bits 16:17 - PLLI2S division factor for SPDIF-IN clock"]
    #[inline]
    pub fn plli2sp(&self) -> PLLI2SPR {
        PLLI2SPR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 24:27 - PLLI2S division factor for SAI1 clock"]
    #[inline]
    pub fn plli2sq(&self) -> PLLI2SQR {
        let bits = {
            const MASK: u8 = 15;
            const OFFSET: u8 = 24;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        PLLI2SQR { bits }
    }
    #[doc = "Bits 28:30 - PLLI2S division factor for I2S clocks"]
    #[inline]
    pub fn plli2sr(&self) -> PLLI2SRR {
        let bits = {
            const MASK: u8 = 7;
            const OFFSET: u8 = 28;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        PLLI2SRR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 536883200 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:5 - Division factor for audio PLL (PLLI2S) input clock"]
    #[inline]
    pub fn plli2sm(&mut self) -> _PLLI2SMW {
        _PLLI2SMW { w: self }
    }
    #[doc = "Bits 6:14 - PLLI2S multiplication factor for VCO"]
    #[inline]
    pub fn plli2sn(&mut self) -> _PLLI2SNW {
        _PLLI2SNW { w: self }
    }
    #[doc = "Bits 16:17 - PLLI2S division factor for SPDIF-IN clock"]
    #[inline]
    pub fn plli2sp(&mut self) -> _PLLI2SPW {
        _PLLI2SPW { w: self }
    }
    #[doc = "Bits 24:27 - PLLI2S division factor for SAI1 clock"]
    #[inline]
    pub fn plli2sq(&mut self) -> _PLLI2SQW {
        _PLLI2SQW { w: self }
    }
    #[doc = "Bits 28:30 - PLLI2S division factor for I2S clocks"]
    #[inline]
    pub fn plli2sr(&mut self) -> _PLLI2SRW {
        _PLLI2SRW { w: self }
    }
}
